// Copyright (c) 2016, <your name>. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

// TODO: Put public facing types in this file.

library orientdb1.base;
import 'dart:html';
import 'dart:async';
import 'dart:convert';

/// Checks if you are awesome. Spoiler: you are.
class Awesome {
  bool get isAwesome => true;
}

class OrientDB1 {
  String user;
  String password;
  String host;
  int port;

  OrientDB1(this.user, this.password, this.host, this.port);
  toURL() => "http://$user:$password@$host:${port}";

  Future<List> listDatabases() {
    Completer completer = new Completer();
    HttpRequest.getString("${toURL()}/listDatabases").then((
        content) {
      var raw = JSON.decode(content);
      List databases = raw['databases'];
      completer.complete(databases);
    });
    return completer.future;
  }

  Future<bool> DatabaseExists(String databaseName) {
    Completer completer = new Completer();
    bool exists;

    HttpRequest.getString("${toURL()}/listDatabases").then((
        content) {
      exists = false;
      var raw = JSON.decode(content);
      List databases = raw['databases'];
      for (var database in databases) {
        if (databaseName == database) {
          exists = true;
        }
      }
      completer.complete(exists);
    });
    return completer.future;
  }

}
